##  --------------------------------------------------------------------------------
##  $Id: Query.pm,v 1.2 2002/12/27 16:02:39 joko Exp $
##  --------------------------------------------------------------------------------
##  $Log: Query.pm,v $
##  Revision 1.2  2002/12/27 16:02:39  joko
##  - object constructor
##  + now utilizing DesignPattern::Object
##  + use Data::Query::Element::LV
##
##  Revision 1.1  2002/12/23 04:23:24  joko
##  + initial check-in
##
##  --------------------------------------------------------------------------------


package Data::Query;

use strict;
use warnings;

use base 'DesignPattern::Object';
use base 'DesignPattern::Object::Logger';


use Data::Dumper;

use Regexp::Group;
use libp qw( mkObject );
use Data::Compare::Struct qw( isEmpty );

use Data::Query::Element::LV;

sub _init {
  my $self = shift;
  
  if ($self->{options}) {
    $self->{__options} = $self->{options};
    delete $self->{options};
    my $possible_keys = $self->{__options}->getPossibleOptionKeys();
    my $options = $self->{__options}->getOptions();
    foreach (@$possible_keys) {
      $self->{$_} = Data::Query::Element::LV->new($options->{$_});
    }
  }

}

sub getOptions {
  my $self = shift;
  return $self->{__options}->getOptions();
}

1;