##  ------------------------------------------------------------------------
##    $Id: Extensions.pm,v 1.1 2003/01/20 16:47:08 joko Exp $
##  ------------------------------------------------------------------------
##    $Log: Extensions.pm,v $
##    Revision 1.1  2003/01/20 16:47:08  joko
##    + initial check-in: refactored from code in Torus::Driver::ldap and/or Data::Storage::Handler::NetLDAP
##
##  ------------------------------------------------------------------------


package Data::Storage::Handler::NetLDAP::Extensions;

use strict;
use warnings;

use mixin::with qw( Data::Storage::Handler::NetLDAP );


use Data::Dumper;
use Net::LDAP;
use Net::LDAP::Entry;

# get logger instance
my $logger = Log::Dispatch::Config->instance;


sub createDn {

  my $self = shift;
  
  my $identifierDn = shift;

  $logger->info( __PACKAGE__ . "->createDn: " . $identifierDn->getContent() );

#print Dumper($identifierDn);
  
=pod
  my $dn = shift;

  print "orig-dn: $dn", "\n";
  
  $dn =~ m/ou=([\w|\.]+?)[,|].*/;
  my $ou = $1;
  #print "ou: '$ou'", "\n";
  
  my $basedn = $dn;
  $basedn =~ s/ou=$ou, //;
  #print "basedn: $basedn", "\n";
  #exit;
=cut
  
  #print "checking ou: (basedn='$basedn', ou='$ou')", "\n" if $DEBUGLEVEL > 3;
  #my $basedn = $self->{options}->{
  #my $basedn = "abc";

  return $self->_createDn($identifierDn);
  
}

sub _createDn {
  my $self = shift;
  #my $dn = shift;
  #my $ou = shift;
  my $identifierDn = shift;
  
  my $dn = $identifierDn->asString();
  
  my $DNs = $identifierDn->getAllRelativeDNs();
  
  #print Dumper($DNs);
  #exit;

  my $core = $self->getCOREHANDLE();
  
  foreach my $dnItem (@$DNs) {

    #print Dumper($dnItem);

    my $entry = Net::LDAP::Entry->new();
    $entry->dn($dnItem->{full});

    $entry->add(
      $identifierDn->getType() => $dnItem->{name},
      objectClass => $identifierDn->getClassName(),
    );

    #print Dumper($identifierDn);
    #print Dumper($entry);
    
    my $result = $entry->update($core);
  
  }
  
  #return $result;
  #return $dn;
  
  return 1;
  
}

1;
