## ------------------------------------------------------------------------
##  $Id: Merge.pm,v 1.2 2002/12/23 13:44:53 joko Exp $
## ------------------------------------------------------------------------
##  $Log: Merge.pm,v $
##  Revision 1.2  2002/12/23 13:44:53  joko
##  + sub stripDayName
##
##  Revision 1.1  2002/12/22 14:15:59  joko
##  + initial check-in
##
## ------------------------------------------------------------------------


package Date::Merge;

use strict;
use warnings;

require Exporter;
our @ISA = qw( Exporter );
our @EXPORT_OK = qw( 
    mergeDayAndTime
    stripDayName
);


use Date::Manip;
use libp qw( today );


sub mergeDayAndTime {

  my $day = shift;
  my $time = shift;
  
  my $date_day_raw = $day;
  my $date_time_raw = $time;

            # TODO: abstract this out (to a helper function) somehow
            # take care not to exclude/export/refactor _this_ type of helper function to nirvana
            # remember just _everything_ out of this scope is nirvana, so - right said - take care to stay in scope ...
            # ... else this compartment would theoretically break, but may still work in real use under some "easy" circumstances
            # (e.g. no other containerships, no parallelity, anything may/might happen)
            # REVIEW: what about re-entrancy of _this_ type of helper functions/methods?
          
              $date_day_raw =~ s/[^\d|-]//g;
              my $date_day = ParseDate($date_day_raw);
    
              # $date_time (just the time!) will get auto-converted to a datetime from today, so ....
              my $date_time = ParseDate($date_time_raw);

              # ... we should calculate the delta to get the real time-shift to continue further processing with
              my $date_time_delta = DateCalc(ParseDate(today()), '-' . $date_time);

              # add the delta to the 'date-day' parsed above to calculate the complete event-date ('endtime' in this case)
              my $date_complete = DateCalc($date_day, $date_time_delta);

              # reformat the complete date to be a full compliant database-date
              my $date_full = UnixDate($date_complete, '%Y-%m-%d %H:%M:%S');

  return $date_full;

}

sub stripDayName {
  
  my $date_raw = shift;
  $date_raw =~ s/[^\d|-]//g;
  
  my $date_parsed = ParseDate($date_raw);
  
  my $date_full = UnixDate($date_parsed, '%Y-%m-%d %H:%M:%S');

  return $date_full;
  
}

1;
