##    --------------------------------------------------------------------------------
##    $Id: Config.pm,v 1.1 2002/12/07 04:17:45 cvsjoko Exp $
##    --------------------------------------------------------------------------------
##    $Log: Config.pm,v $
##    Revision 1.1  2002/12/07 04:17:45  cvsjoko
##    + moved here from base 'etc/'
##
##    Revision 1.2  2002/10/16 04:01:51  cvsjoko
##    + changes to logging settings (debug)
##
##    Revision 1.1  2002/10/10 03:23:55  cvsjoko
##    + new
##    --------------------------------------------------------------------------------


package Log::Dispatch::Configurator::Hardwired;
use base qw(Log::Dispatch::Configurator);

use strict;
use warnings;

sub get_attrs_global {
    my $self = shift;
    my @dispatchers;
    
    # push all loggers to @dispatchers
    push @dispatchers, 'screen';
    #print "logfile: ", $self->{logfile}, "\n";
    push @dispatchers, 'file' if ($self->{file_filename});
    
    print "logging to [", join(" ", @dispatchers), "]", "\n" if ($self->{verbose});
    return {
        format => undef,
        dispatchers => \@dispatchers,
    };
}

sub get_attrs {
    my($self, $name) = @_;
    if ($name eq 'file') {
        return {
            class     => 'Log::Dispatch::File',
            min_level => 'debug',
            #filename  => '/path/to/log',
            filename  => $self->{file_filename},
            mode      => 'append',
            #format  => '[%d] [%p] %m at %F line %L%n',
            format  => '[%d] [%p] %m%n',
        };
    }
    elsif ($name eq 'screen') {
        return {
            class     => 'Log::Dispatch::Screen',
            #min_level => 'info',
            min_level => 'debug',
            #min_level => 'error',
            min_level => $self->{screen_min_level},
            stderr    => 1,
            format  => '%p: %m%n',
        };
    }
    else {
        die "invalid dispatcher name: $name";
    }
}

1;