#################################
#
#  $Id: HashExt.pm,v 1.1 2002/10/10 03:44:54 cvsjoko Exp $
#
#  $Log: HashExt.pm,v $
#  Revision 1.1  2002/10/10 03:44:54  cvsjoko
#  + new
#
#
#################################


package OneLineDumpHash;

use strict;
use warnings;

use overload
  '""' => \&stringify,
  ;

sub new {
  #print "new: ", __PACKAGE__, "\n";
  my $class = shift;
  my $value = shift;
  #tie(%{$value}, "Tie::IxHash");
  #return bless \$value => $class;  
  return bless $value => $class;  
}

sub stringify {
  my ($x, $y) = @_;
  
  # dereference value
  # TODO: clear this!!!
  my $value;
  if ( ref($x) eq 'OneLineDumpHash' ) {
   $value = $x;
  } else {
   $value = $$x;
  }
  
  my @entries;
  foreach my $h_key (keys %{$value}) {
    my $h_val = $value->{$h_key};
    push @entries, "$h_key: $h_val";
  }
  return join "  /  ", @entries;
}


package SummableHash;

use strict;
use warnings;

use base qw(OneLineDumpHash);

use overload
  '+=' => \&sum_hash,
  ;

use Tie::IxHash;
use Data::Dumper;

sub new {
  #print "new: ", __PACKAGE__, "\n";
  my $class = shift;
  my $value = shift;
  tie(%{$value}, "Tie::IxHash");
  return bless \$value => $class;  
}


sub sum_hash {
  
  #print Dumper(@_);
  my ($x, $y) = @_;
  #print "x: ";
  #print Dumper($x);
  #print "y: ";
  #print Dumper($y);
  my $value = $$x;
  
  #$value->{sumCount}++;
  foreach my $key (keys %{$y}) {
    # initialize key if undefined yet to prevent "Use of uninitialized value in addition (+) at [...]"
    $value->{$key} ||= 0;
    # sum up statistic-counts
    $value->{$key} += $y->{$key};
  }
  
  return bless \$value => ref($x);
}

1;