## ---------------------------------------------------------------------------
##  $Id: shortcuts.pm,v 1.2 2003/01/20 21:19:27 joko Exp $
## ---------------------------------------------------------------------------
##  $Log: shortcuts.pm,v $
##  Revision 1.2  2003/01/20 21:19:27  joko
##  + updated 'sub now': knows about option 'fs' now
##
##  Revision 1.1  2003/01/19 02:08:08  joko
##  + initial check-in
##
## ---------------------------------------------------------------------------


package org::netfrag::shortcuts;

use strict;
use warnings;

require Exporter;
our @ISA = qw( Exporter );
our @EXPORT_OK = qw( 
  now today
  run_cmd run_cmds
);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -   main

use Data::Dumper;
use POSIX qw(strftime);

# $now_string = strftime "%a %b %e %H:%M:%S %Y", localtime;
# see "perldoc -f localtime"

sub now {
  my $options = shift;
  my $pattern = "%Y-%m-%d %H:%M:%S";
  $pattern = "%Y-%m-%d_%H-%M-%S" if $options->{fs};
  my $result = strftime($pattern, localtime);
  return $result;
}

sub today {
  return strftime("%Y-%m-%d", localtime);
}

sub run_cmd {
  my $cmd = shift;
  my $caption = shift;
  #$cmd = 'perl ' . $cmd;
  my $sep = "-" x 90;
  print $sep, "\n";
  print "  ", $cmd, "\n";
  print "  ", $caption, "\n" if $caption;
  print $sep, "\n";
  system($cmd);
  #`$cmd`;
  print "ready.", "\n";
}

sub run_cmds {
  foreach (@_) {
    run_cmd($_);
  }
}


1;
